Simple Bubble in JavaScript

Using ApexCharts with JavaScript

This Simple Bubble example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// Seeded PRNG so the bubbles are identical on every load (stable snapshots).
var __seed = 0x7ab19c3d
function rand() {
  __seed |= 0
  __seed = (__seed + 0x6d2b79f5) | 0
  var t = Math.imul(__seed ^ (__seed >>> 15), 1 | __seed)
  t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
  return ((t ^ (t >>> 14)) >>> 0) / 4294967296
}

// Each point is [revenue $M, growth %, headcount]. The third value is the
// bubble size, so a bigger bubble = a bigger workforce.
function generateData(count, xrange, yrange, zrange) {
  var series = []
  for (var i = 0; i < count; i++) {
    var x = Math.floor(rand() * (xrange.max - xrange.min + 1)) + xrange.min
    var y = Math.floor(rand() * (yrange.max - yrange.min + 1)) + yrange.min
    var z = Math.floor(rand() * (zrange.max - zrange.min + 1)) + zrange.min
    series.push([x, y, z])
  }
  return series
}

var options = {
  series: [
    {
      name: 'SaaS',
      data: generateData(
        12,
        { min: 20, max: 200 },
        { min: 25, max: 65 },
        { min: 20, max: 60 },
      ),
    },
    {
      name: 'Retail',
      data: generateData(
        12,
        { min: 150, max: 480 },
        { min: 5, max: 30 },
        { min: 40, max: 75 },
      ),
    },
    {
      name: 'Fintech',
      data: generateData(
        12,
        { min: 60, max: 320 },
        { min: 15, max: 50 },
        { min: 15, max: 55 },
      ),
    },
    {
      name: 'Hardware',
      data: generateData(
        12,
        { min: 100, max: 400 },
        { min: 2, max: 20 },
        { min: 30, max: 70 },
      ),
    },
  ],
  chart: {
    height: 350,
    type: 'bubble',
  },
  dataLabels: {
    enabled: false,
  },
  fill: {
    opacity: 0.8,
  },
  title: {
    text: 'Companies: Revenue vs Growth',
  },
  subtitle: {
    text: 'Bubble size = headcount',
  },
  xaxis: {
    tickAmount: 10,
    type: 'numeric',
    min: 0,
    max: 500,
    title: {
      text: 'Revenue ($M)',
    },
  },
  yaxis: {
    max: 70,
    title: {
      text: 'YoY Growth (%)',
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Simple Bubble in Vue

Using ApexCharts with Vue

This Simple Bubble example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="bubble"
        height="350"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// Seeded PRNG so the bubbles are identical on every load (stable snapshots).
var __seed = 0x7ab19c3d
function rand() {
  __seed |= 0
  __seed = (__seed + 0x6d2b79f5) | 0
  var t = Math.imul(__seed ^ (__seed >>> 15), 1 | __seed)
  t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
  return ((t ^ (t >>> 14)) >>> 0) / 4294967296
}

// Each point is [revenue $M, growth %, headcount]. The third value is the
// bubble size, so a bigger bubble = a bigger workforce.
function generateData(count, xrange, yrange, zrange) {
  var series = []
  for (var i = 0; i < count; i++) {
    var x = Math.floor(rand() * (xrange.max - xrange.min + 1)) + xrange.min
    var y = Math.floor(rand() * (yrange.max - yrange.min + 1)) + yrange.min
    var z = Math.floor(rand() * (zrange.max - zrange.min + 1)) + zrange.min
    series.push([x, y, z])
  }
  return series
}

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'SaaS',
          data: generateData(
            12,
            { min: 20, max: 200 },
            { min: 25, max: 65 },
            { min: 20, max: 60 },
          ),
        },
        {
          name: 'Retail',
          data: generateData(
            12,
            { min: 150, max: 480 },
            { min: 5, max: 30 },
            { min: 40, max: 75 },
          ),
        },
        {
          name: 'Fintech',
          data: generateData(
            12,
            { min: 60, max: 320 },
            { min: 15, max: 50 },
            { min: 15, max: 55 },
          ),
        },
        {
          name: 'Hardware',
          data: generateData(
            12,
            { min: 100, max: 400 },
            { min: 2, max: 20 },
            { min: 30, max: 70 },
          ),
        },
      ],
      chartOptions: {
        chart: {
          height: 350,
          type: 'bubble',
        },
        dataLabels: {
          enabled: false,
        },
        fill: {
          opacity: 0.8,
        },
        title: {
          text: 'Companies: Revenue vs Growth',
        },
        subtitle: {
          text: 'Bubble size = headcount',
        },
        xaxis: {
          tickAmount: 10,
          type: 'numeric',
          min: 0,
          max: 500,
          title: {
            text: 'Revenue ($M)',
          },
        },
        yaxis: {
          max: 70,
          title: {
            text: 'YoY Growth (%)',
          },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

Simple Bubble in Angular

Using ApexCharts with Angular

This Simple Bubble example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'SaaS',
              data: generateData(
                12,
                { min: 20, max: 200 },
                { min: 25, max: 65 },
                { min: 20, max: 60 },
              ),
            },
            {
              name: 'Retail',
              data: generateData(
                12,
                { min: 150, max: 480 },
                { min: 5, max: 30 },
                { min: 40, max: 75 },
              ),
            },
            {
              name: 'Fintech',
              data: generateData(
                12,
                { min: 60, max: 320 },
                { min: 15, max: 50 },
                { min: 15, max: 55 },
              ),
            },
            {
              name: 'Hardware',
              data: generateData(
                12,
                { min: 100, max: 400 },
                { min: 2, max: 20 },
                { min: 30, max: 70 },
              ),
            },
          ],
          chart: {
            height: 350,
            type: 'bubble',
          },
          dataLabels: {
            enabled: false,
          },
          fill: {
            opacity: 0.8,
          },
          title: {
            text: 'Companies: Revenue vs Growth',
          },
          subtitle: {
            text: 'Bubble size = headcount',
          },
          xaxis: {
            tickAmount: 10,
            type: 'numeric',
            min: 0,
            max: 500,
            title: {
              text: 'Revenue ($M)',
            },
          },
          yaxis: {
            max: 70,
            title: {
              text: 'YoY Growth (%)',
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Simple Bubble in React

Using ApexCharts with React

This Simple Bubble example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// Seeded PRNG so the bubbles are identical on every load (stable snapshots).
var __seed = 0x7ab19c3d
function rand() {
  __seed |= 0
  __seed = (__seed + 0x6d2b79f5) | 0
  var t = Math.imul(__seed ^ (__seed >>> 15), 1 | __seed)
  t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
  return ((t ^ (t >>> 14)) >>> 0) / 4294967296
}

// Each point is [revenue $M, growth %, headcount]. The third value is the
// bubble size, so a bigger bubble = a bigger workforce.
function generateData(count, xrange, yrange, zrange) {
  var series = []
  for (var i = 0; i < count; i++) {
    var x = Math.floor(rand() * (xrange.max - xrange.min + 1)) + xrange.min
    var y = Math.floor(rand() * (yrange.max - yrange.min + 1)) + yrange.min
    var z = Math.floor(rand() * (zrange.max - zrange.min + 1)) + zrange.min
    series.push([x, y, z])
  }
  return series
}

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'SaaS',
        data: generateData(
          12,
          { min: 20, max: 200 },
          { min: 25, max: 65 },
          { min: 20, max: 60 },
        ),
      },
      {
        name: 'Retail',
        data: generateData(
          12,
          { min: 150, max: 480 },
          { min: 5, max: 30 },
          { min: 40, max: 75 },
        ),
      },
      {
        name: 'Fintech',
        data: generateData(
          12,
          { min: 60, max: 320 },
          { min: 15, max: 50 },
          { min: 15, max: 55 },
        ),
      },
      {
        name: 'Hardware',
        data: generateData(
          12,
          { min: 100, max: 400 },
          { min: 2, max: 20 },
          { min: 30, max: 70 },
        ),
      },
    ],
    options: {
      chart: {
        height: 350,
        type: 'bubble',
      },
      dataLabels: {
        enabled: false,
      },
      fill: {
        opacity: 0.8,
      },
      title: {
        text: 'Companies: Revenue vs Growth',
      },
      subtitle: {
        text: 'Bubble size = headcount',
      },
      xaxis: {
        tickAmount: 10,
        type: 'numeric',
        min: 0,
        max: 500,
        title: {
          text: 'Revenue ($M)',
        },
      },
      yaxis: {
        max: 70,
        title: {
          text: 'YoY Growth (%)',
        },
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="bubble"
          height={350}
        />
      </div>
    </div>
  )
}

export default ApexChart